﻿#include "stdafx.h"
#include "NeMessenger.h"
#include "NeMessengerDlg.h"
#include "ConfigPersonal.h"
#include "CommonFunction.h"


#define MAX_RENAME_LENGTH			20

#define MAX_AWAY_COUNT 6
const int c_nAwayTime[MAX_AWAY_COUNT] = {3, 5, 10, 15, 20, 30};

IMPLEMENT_DYNAMIC(CConfigPersonal, CConfigBaseDlg)
CConfigPersonal::CConfigPersonal(CWnd* pParent /*=NULL*/)
	: CConfigBaseDlg(CConfigPersonal::IDD, pParent)
	, strMaxLen(_T(""))
{
	m_rcNickNameTitleText.SetRect(20,32,110,52);
	m_rcAwayTitleText.SetRect(20,102,115,122);
	m_rcNickNameText.SetRect(115,32,360,51);
	m_rcAwayText.SetRect(178,104,373,125);
	nAwayTimeSpin = GET_CONFIG()->GetAutoAwayTime();
	m_pEditBkBrush = new CBrush(RGB(255, 255, 255));
}

CConfigPersonal::~CConfigPersonal()
{
	m_pEditBkBrush->DeleteObject();
	SAFE_DELETE(m_pEditBkBrush);
}

void CConfigPersonal::DoDataExchange(CDataExchange* pDX)
{
	CConfigBaseDlg::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_NICKNAME, m_edNickName);
	DDX_Control(pDX, IDC_CHECK_AWAY_STATE, m_chkAwayState);
	//DDX_Control(pDX, IDC_EDIT_AWAY_TIME, m_edAwayTime);
	//DDX_Text(pDX, IDC_EDIT_AWAY_TIME, m_nAwayTime);
	DDX_Text(pDX, IDC_EDIT_NICKNAME, strMaxLen);
	DDV_MaxChars(pDX, strMaxLen, NICKNAME_MAX_LENGTH);
	//DDX_Control(pDX, IDC_AWAY_SPIN, m_spinAway);
	DDX_Control(pDX, IDC_COMBO_AWAY, m_comboAway);
}

BEGIN_MESSAGE_MAP(CConfigPersonal, CConfigBaseDlg)
	ON_WM_ERASEBKGND()
	ON_COMMAND(IDC_CHECK_AWAY_STATE, OnCheckAwayState)
	//ON_NOTIFY(UDN_DELTAPOS, IDC_AWAY_SPIN, &CConfigPersonal::OnDeltaposAwaySpin)
	ON_WM_CTLCOLOR()
	ON_EN_CHANGE(IDC_EDIT_NICKNAME, &CConfigPersonal::OnEnChangeEditNickname)
	ON_CBN_SELCHANGE(IDC_COMBO_AWAY, &CConfigPersonal::OnCbnSelchangeComboAway)
END_MESSAGE_MAP()


BOOL CConfigPersonal::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE)
		{
			return TRUE;
		}
		else if(pMsg->wParam == VK_RETURN)
		{			
			
			return TRUE;
		}
	}
	else if(pMsg->message == WM_CLOSE)
	{
		OnOK();
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}
BOOL CConfigPersonal::OnInitDialog()
{
	CConfigBaseDlg::OnInitDialog();	

	int nLeft = 115;
	m_chkAwayState.SetBitmapFile(GetAppImgFile(_T("checkbox.bmp")),RGB(0,0,0));
	m_edNickName.MoveWindow(nLeft,58,260,21,TRUE);
	m_edNickName.SetLimitText(NICKNAME_MAX_LENGTH);
	m_chkAwayState.MoveWindow(nLeft,104,11,11,TRUE);	
	//m_edAwayTime.MoveWindow(116,101,15,21,TRUE);
	m_comboAway.MoveWindow(nLeft + 15, 101, 43, 21, TRUE);
	m_comboAway.SetTextColor(RGB(102, 102, 102));

	m_comboAway.ResetContent();
	CString strBuf = _T("");
	for (int i=0; i<MAX_AWAY_COUNT; ++i)
	{
		strBuf.Format(_T("%d"), c_nAwayTime[i]);
		m_comboAway.InsertString(i, strBuf);
	}

	//AddClickAssociateInfo(&m_chkAwayState, m_rcAwayText);
	initData();
	
    RECT rect = {0};
	m_edNickName.GetClientRect(&rect);
	OffsetRect(&rect,7,4); 
	::SendMessage(m_edNickName.m_hWnd, EM_SETRECT, 0, (LPARAM)&rect);

	return TRUE;
}

void CConfigPersonal::initData()
{
	m_edNickName.SetWindowText(GET_CONFIG()->GetNickName());
	int nValue = GET_CONFIG()->GetAutoAwayState();
	DDX_CHECKBOX_VALUE(m_chkAwayState,nValue,FALSE);
	if (nValue)
	{
		m_comboAway.EnableWindow(TRUE);
	}
	else
	{
		m_comboAway.EnableWindow(FALSE);
	}
	
	BOOL bFind = FALSE;
	for (int i=0; i<MAX_AWAY_COUNT; ++i)
	{
		if (c_nAwayTime[i] == GET_CONFIG()->GetAutoAwayTime())
		{
			m_comboAway.SetCurSel(i);
			bFind = TRUE;
			break;
		}
	}
	if (!bFind)
	{
		m_comboAway.SetCurSel(0);
	}
}

bool CConfigPersonal::DoApply()
{
	UpdateData(TRUE);
	CString strNickName;
	m_edNickName.GetWindowText(strNickName);
	
	if (strNickName.Find(_T('|')) >= 0)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING_MAIN_INVALIDNICKNAME));
		return false;
	}

	int nValue = 0;
	DDX_CHECKBOX_VALUE(m_chkAwayState,nValue,TRUE);
	GET_CONFIG()->SetAutoAwayState(nValue);

	if((GET_CONFIG()->GetAutoAwayState()) && (nAwayTimeSpin>0)) 
	{
		GET_MESSENGER_DLG()->m_IdleMonitor->ResumeMonitorInput();
	}
	else
	{
		GET_MESSENGER_DLG()->m_IdleMonitor->PauseMonitorInput();
	}


	GET_CONFIG()->SetChangeNickName(strNickName);
	return true;
}


BOOL CConfigPersonal::OnEraseBkgnd(CDC* pDC)
{
	BOOL bRet = CConfigBaseDlg::OnEraseBkgnd(pDC);
	//LoadStringFromResource(IDS_STRING424)
	CFont *pOldFont = pDC->SelectObject(&g_ftDefault10PT);
	COLORREF oldColor = pDC->SetTextColor(CONFIGPERSONAL_TITLE_TEXT_COLOR);
	pDC->SetBkMode(TRANSPARENT);

    //CRect rc(0, 0, 0, 0);
//	pDC->DrawText(LoadStringFromResource(IDS_STRING424), &rc, DT_NOPREFIX | DT_CALCRECT);
//	m_rcNickNameTitleText.right = m_rcNickNameTitleText.left + rc.Width();
//	m_rcNickNameTitleText.bottom = m_rcNickNameTitleText.top + rc.Height();

	pDC->DrawText(LoadStringFromResource(IDS_STRING424),m_rcNickNameTitleText,DT_LEFT);


	pDC->DrawText(LoadStringFromResource(IDS_STRING425),m_rcAwayTitleText,DT_LEFT);
	pDC->SelectObject(&g_ftDefault9PT);
	pDC->SetTextColor(CONFIGPERSONAL_BASIC_TEXT_COLOR);

	//pDC->DrawText(LoadStringFromResource(IDS_STRING426), &rc, DT_NOPREFIX | DT_CALCRECT);

	//m_rcNickNameText.left = m_rcNickNameTitleText.right + 4;
//	m_rcNickNameText.right = m_rcNickNameText.left + rc.Width();
//	m_rcNickNameText.top = m_rcNickNameTitleText.top + 1;
//	m_rcNickNameText.bottom = m_rcNickNameText.top + rc.Height();
	pDC->DrawText(LoadStringFromResource(IDS_STRING426),m_rcNickNameText,DT_LEFT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING427),m_rcAwayText,DT_LEFT);

	pDC->SetTextColor(oldColor);	
	pDC->SelectObject(pOldFont);

	return bRet;
}

void CConfigPersonal::OnDeltaposAwaySpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	if (pNMUpDown->iDelta >0)
	{
		if (nAwayTimeSpin>= 60)
		{
			CString strString;
			strString.LoadString(IDS_STRING211);//弥措汲沥矫埃篮 60盒涝聪促.
			AfxMessageBox(strString);
			return;
		}
		nAwayTimeSpin++;
	}
	else
	{
		if (nAwayTimeSpin<=5)
		{
			CString strString;
			strString.LoadString(IDS_STRING210);//弥家汲沥矫埃篮 5盒涝聪促
			AfxMessageBox(strString);
			return;
		}
		nAwayTimeSpin--;
	}
	SetDlgItemInt(IDC_EDIT_AWAY_TIME,nAwayTimeSpin);
	GET_CONFIG()->SetAutoAwayTime(nAwayTimeSpin);
	*pResult = 0;
}

void CConfigPersonal::OnCheckAwayState()
{
	int nValue = 0;
	DDX_CHECKBOX_VALUE(m_chkAwayState,nValue,TRUE);
	//TRACE(TEXT("m_chkAwayState.GetCheck=%d, nValue=%d\n"), m_chkAwayState.GetCheck(), nValue);
	if (nValue)
	{
		m_comboAway.EnableWindow(TRUE);
	}
	else
	{
		m_comboAway.EnableWindow(FALSE);
	}
}
HBRUSH CConfigPersonal::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CConfigBaseDlg::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  Change any attributes of the DC here
	if(pWnd == &m_edNickName)
	{
		pDC->SetBkColor(RGB(255,255,255));
		pDC->SetBkMode(TRANSPARENT);
		pDC->SetTextColor(RGB(102,102,102));
		return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
	}
	// TODO:  Return a different brush if the default is not desired
	return hbr;
}

void CConfigPersonal::OnEnChangeEditNickname()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CConfigBaseDlg::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	m_edNickName.Invalidate(FALSE);
}

void CConfigPersonal::OnCbnSelchangeComboAway()
{
	// TODO: Add your control notification handler code here
	int nSel = m_comboAway.GetCurSel();
	if (nSel < 0)
	{
		nSel = 0;
	}
	GET_CONFIG()->SetAutoAwayTime(c_nAwayTime[nSel]);
}
